config/routes.rb
Rails.application.routes.draw do
  get 'order_items/show'
  get 'checkouts/index'
  resources :order_items
  resources :cart
  devise_for :users, :controllers => { registrations: 'registrations'}
  resources :admins
  resources :users
  resources :products
  resources :vendors
  resources :orders
  root to: "home#index"
  get 'home/index'
  post "checkout/create", to: "checkout#create"
  post "products/add_to_cart/:id", to: "products#add_to_cart", as: "add_to_cart"
  delete "products/remove_from_cart/:id", to: "products#remove_from_cart", as: "remove_from_cart"
  # resources :webhooks, only: [:create]
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/order.rb
class Order < ApplicationRecord
  has_many :order_items, dependent: :destroy
  has_one :user
end

app/models/order_item.rb
class OrderItem < ApplicationRecord
	belongs_to :order
	belongs_to :product
end

app/models/product.rb
class Product < ApplicationRecord
  belongs_to :user

  has_many_attached :images

  has_many :order_items
end

app/models/role.rb
class Role < ApplicationRecord
  has_and_belongs_to_many :users, :join_table => :users_roles
  
  belongs_to :resource,
             :polymorphic => true,
             :optional => true
  

  validates :resource_type,
            :inclusion => { :in => Rolify.resource_types },
            :allow_nil => true

  scopify
end

app/models/user.rb
class User < ApplicationRecord
  has_many :products, :dependent => :destroy
  has_many :order
  
  rolify
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable, :trackable
  
  after_create :assign_default_role

  validate :must_have_a_role, on: :update

  validate :must_have_a_role, on: :new

  after_create do 
    customer = Stripe::Customer.create(email: email)
    update(stripe_customer_id: customer.id)
  end

  private

  def must_have_a_role
    unless roles.any?
      errors.add(:roles, "Must have at least 1 role")
    end
  end

  def assign_default_role
    self.add_role(:User) if self.roles.blank?
  end

end

app/controllers/admins_controller.rb
class AdminsController < ApplicationController
    before_action :confirm_role
    def index
        @users = User.all
    end
    def show
        @user = User.find(params[:id])
    end
    def edit
        @user = User.find(params[:id])
    end
    def update
        @user = User.find(params[:id])
        if @user.update(user_params)
            redirect_to admins_path, notice: "User successfly updated."
        else
            render :edit
        end
    end
    def delete
        @user = User.find(params[:id])
    end

    def destroy
        user = User.find(params[:id]).destroy
        flash[:notice] = "User '#{user.username}' destroyed successfully."
        redirect_to(:action => 'index')
    end

    private
    def user_params
        params.require(:user).permit({role_ids: []})
    end

    def confirm_role
        unless current_user.has_role? :Admin
          redirect_to root_path, alert: "You are not authorized."
        end
    end
end

app/controllers/cart_controller.rb
class CartController < ApplicationController
  def index
    # if session[:cart]
    #   @products = Product.where(id: session[:cart])
    # end
  end 
end

app/controllers/home_controller.rb
class HomeController < ApplicationController
  # before_action :confirm_role
  def index
    if current_user.has_role? :Admin
        redirect_to admins_path
    elsif current_user.has_role? :Vendor
        redirect_to vendors_path
    else
      @products=Product.all
    end
  end
end

app/controllers/orders_controller.rb
class OrdersController < ApplicationController
  def index
    @orders=Order.all
  end

  def show
    user=User.find(params[:id])
    @order=user.order
  end

  def create
    @order=Order.new(order_params)
    if @order.save
      @order_item=(JSON.parse params[:cart]).map{|p| OrderItem.new(p)}
      k=@order_item.length
      k.times { |i| @order_item[i].order = @order }
      k.times { |i| @order_item[i].subtotal = params[:subtotal] }
      k.times { |i| @order_item[i].save }
      respond_to do |format|
        format.json { render :inline => "{}" }
      end
    else
      redirect_to 'checkouts/index'
    end
  end

  def edit
    @orde=Order.find(params[:id])
  end

  def update
    @orde = Order.find(params[:id])
    if @orde.update(update_params)
      flash[:notice] = "Order updated successfully."
      redirect_to orders_path
    else
      render('edit')
    end
  end

  def destroy
    order = Order.find(params[:id]).destroy
    flash[:notice] = "Order destroyed successfully."
    redirect_to order_path(:id => current_user.id)
  end

  private

  def order_params
    params.permit(:user_id, :address)
  end

  def order_item_params
    params.permit(:subtotal, cart: [] )
  end

  def update_params
    params.permit(:status)
  end
end

app/controllers/products_controller.rb
class ProductsController < ApplicationController
  before_action :find_user, only: [:index]
  before_action :confirm_role, only: [:new, :create, :edit, :update, :destroy]

  def index
    @products = @user.products
  end

  def show
    @product = Product.find(params[:id])
  end

  def new
    @product = Product.new
  end

  def create
    @product = Product.new(product_params)
    if @product.save
      flash[:notice] = "Product created successfully."
      redirect_to products_path(:id => current_user.id)
    else
      redirect_to cart_index_path, method: :get
    end
  end

  def edit
    @product = Product.find(params[:id])
  end

  def update
    @product = Product.find(params[:id])
    if @product.update(product_params)
      flash[:notice] = "Product updated successfully."
      redirect_to products_path(:id => current_user.id)
    else
      render('edit')
    end
  end

  def delete
    @product = Product.find(params[:id])
  end

  def destroy
    product = Product.find(params[:id]).destroy
    flash[:notice] = "Product destroyed successfully."
    redirect_to products_path(:id => current_user.id)
  end

  private

    def product_params
      params.require(:product).permit(:user_id, :title, :quantity, :price, :description, images: [])
    end

    def find_user
      if params[:id]
        @user = User.find(params[:id])
      end
    end

    def confirm_role
      unless current_user.has_role? :Vendor
        redirect_to root_path, alert: "You are not authorized."
      end
  end
end

app/controllers/users_controller.rb
class UsersController < ApplicationController
  def update
    @user = User.find(params[:id])
    if @user.update(user_params)
        redirect_to admins_path, notice: "User successfly updated."
    else
        render :edit
    end
  end

  private
  def user_params
    params.require(:user).permit({role_ids: []})
  end
end

app/helpers/admins_helper.rb
module AdminsHelper
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/cart_helper.rb
module CartHelper
end

app/helpers/checkouts_helper.rb
module CheckoutsHelper
end

app/helpers/home_helper.rb
module HomeHelper
end

app/helpers/order_items_helper.rb
module OrderItemsHelper
end

app/helpers/orders_helper.rb
module OrdersHelper
end

app/helpers/product_helper.rb
module ProductHelper
end

app/helpers/registrations_helper.rb
module RegistrationsHelper
end

app/helpers/users_helper.rb
module UsersHelper
end

app/helpers/vendors_helper.rb
module VendorsHelper
end

app/views/products/_form.html.erb
<%= form_with model: product, remote: true do |form| %>
  
  <%= form.hidden_field :user_id, value:current_user.id  %>

  <div>
    <%= form.label :images %><br>
    <%= form.file_field :images, multiple:true %><br>
  </div>
  
  <div>
    <%= form.label :title %><br>
    <%= form.text_field :title %><br>
  </div>

  <div>
    <%= form.label :quantity %><br>
    <%= form.text_field :quantity %><br>
  </div>

  <div>
    <%= form.label :price %><br>
    <%= form.text_field :price %><br>
  </div>

  <div>
    <%= form.label :description %><br>
    <%= form.text_area :description %><br>
  </div>

  <div>
    <%= form.submit %>
  </div>
<% end %>

app/views/products/edit.html.erb
<div class="container p-2">
  <h1>Edit Product</h1>
  <%= render "form", product: @product %>
</div>

app/views/products/index.html.erb
<div class="container p-3">
    <div class="row">
        <% if current_user.has_role? :Admin %>
            <div class="col">
                <%= link_to "<< Back", admins_path %>
            </div>
        <% end %>
        <% if current_user.has_role? :Vendor %>
        <div class="col">
                <%= link_to "<< Back", vendors_path %>
            </div>
        <div class="col text-right">
            <%= link_to "Add new product", new_product_path %>
        </div>
        <% end %>
    </div> 
    <br>
    <div class="table-responsive">
        <table class="table table-striped text-center">
            <tr class="header">
                <% if current_user.has_role? :Admin %>
                    <th>Vendor Name</th>
                <% end %>
                <th>Product</th>
                <th>Images</th>
                <th>Quantity</th>
                <th>Price</th>
                <th>Description</th>
                <th>Actions</th>
            </tr>
            <% @products.each do |product| %>
            <tr>
                <% if current_user.has_role? :Admin %>
                    <td><%= product.user.username if product.user %></td>
                <% end %>
                <td><%= product.title %></td>
                <td>
                    <ul class="list-unstyled">
                        <% if product.images.attached? %>
                            <% product.images.each do |image| %>
                            <li>
                                <%= image_tag image, width:"100px" %>  
                            </li>
                            <% end %>
                        <% end %>
                    </ul>
                </td>
                <td><%= product.quantity %></td>
                <td><%= product.price %></td>
                <td><%= product.description %></td>
                <td class="actions">
                    <div class="row">
                        <div class="col">
                            <%= link_to "Show", product_path(:id => product) %>
                            <% if current_user.has_role? :Vendor %>
                                <%= link_to "edit", edit_product_path(product) %>
                                <%= link_to "Destroy", product_path(product.id),
                                method: :delete,
                                data: { confirm: "Are you sure?" } %> 
                            <% end %>    
                        </div>
                    </div>
                </td>
            </tr>
            <% end %>
        </table>
    </div>
</div>

app/views/products/new.html.erb
<div class="container p-3">
  <h1>New Product</h1>

  <%= render "form", product: @product %>

</div>

app/views/products/show.html.erb
<div class="container p-3">
  <div class="row">
    <div class="col">
      <%= link_to("<< Back to List", products_path(:id=> @product.user.id)) %>
    </div>
    <div class="col-8">
      <h2>Show Product</h2>
    </div>
  </div> 
  
  <div class="table-responsive">
    <table class="table table-striped">
      <tr>
        <th>User ID</th>
        <td><%= @product.user_id %></td>
      </tr>
      <tr>
        <th>Title</th>
        <td><%= @product.title %></td>
      </tr>
      <tr>
        <th>Images</th>
        <td>
          <ul class="list-unstyled">
            <% if @product.images.attached? %>
              <% @product.images.each do |image| %>
              <li>
                  <%= image_tag image, width:"200px" %>  
              </li>
              <% end %>
            <% end %>
          </ul>
        </td>
      </tr>
      <tr>
        <th>Quantity</th>
        <td><%= @product.quantity %></td>
      </tr>
      <tr>
        <th>Price</th>
        <td><%= @product.price %></td>
      </tr>
      <tr>
        <th>Description</th>
        <td><%= @product.description %></td>
      </tr>    
      <tr>
        <th>Created</th>
        <td><%= @product.created_at %></td>
      </tr>
      <tr>
        <th>Updated</th>
        <td><%= @product.updated_at %></td>
      </tr>
    </table>
  </div>
</div>